az [2017-12-18 Mon 14:20]
historic relevance only - all recent versions of busybox have a working mdev
that handles all uevent actions properly.



--- mdev.c.orig	2012-05-04 23:39:53.000000000 +1000
+++ mdev.c.pluschange	2012-05-04 23:39:23.000000000 +1000
@@ -138,8 +138,9 @@
  * after NUL, but we promise to not mangle (IOW: to restore if needed)
  * path string.
  * NB2: "mdev -s" may call us many times, do not leak memory/fds!
+ * when: 0 add, 1 delete, 2 change
  */
-static void make_device(char *path, int delete)
+static void make_device(char *path, int when)
 {
 	char *device_name, *subsystem_slash_devname;
 	int major, minor, type, len;
@@ -152,7 +153,7 @@
 	 * We also depend on path having writeable space after it.
 	 */
 	major = -1;
-	if (!delete) {
+	if (when==0 /* add */) {
 		char *dev_maj_min = path + strlen(path);
 
 		strcpy(dev_maj_min, "/dev");
@@ -354,7 +355,7 @@
 			}
 
 			if (ENABLE_FEATURE_MDEV_EXEC && val) {
-				const char *s = "$@*";
+				const char *s = "@$*";
 				const char *s2 = strchr(s, val[0]);
 
 				if (!s2) {
@@ -365,13 +366,9 @@
 				}
 
 				/* Are we running this command now?
-				 * Run $cmd on delete, @cmd on create, *cmd on both
-				 */
-				if (s2 - s != delete) {
-					/* We are here if: '*',
-					 * or: '@' and delete = 0,
-					 * or: '$' and delete = 1
+				 * Run $cmd and *cmd on delete, @cmd and *cmd on create, *cmd on change
 					 */
+				if (s2-s==when || *s2=='*') {
 					command = xstrdup(val + 1);
 				}
 			}
@@ -387,7 +384,7 @@
 			if (ENABLE_FEATURE_MDEV_RENAME && alias)
 				node_name = alias = build_alias(alias, device_name);
 
-			if (!delete && major >= 0) {
+			if (when==0 /* create */ && major >= 0) {
 				if (mknod(node_name, mode | type, makedev(major, minor)) && errno != EEXIST)
 					bb_perror_msg("can't create '%s'", node_name);
 				if (major == G.root_major && minor == G.root_minor)
@@ -415,7 +412,7 @@
 				free(command);
 			}
 
-			if (delete && major >= -1) {
+			if (when==1 /* delete */ && major >= -1) { 
 				if (ENABLE_FEATURE_MDEV_RENAME && alias) {
 					if (aliaslink == '>')
 						unlink(device_name);
@@ -584,8 +581,8 @@
 		char *seq;
 		char *action;
 		char *env_path;
-		static const char keywords[] ALIGN1 = "remove\0add\0";
-		enum { OP_remove = 0, OP_add };
+		static const char keywords[] ALIGN1 = "remove\0add\0change\0";
+		enum { OP_remove = 0, OP_add, OP_change };
 		smalluint op;
 
 		/* Hotplug:
@@ -640,6 +637,9 @@
 					load_firmware(fw, temp);
 			}
 		}
+		else if (op == OP_change) {
+		   make_device(temp, /* delete: */ 2);
+		}
 
 		if (seq) {
 			xopen_xwrite_close("mdev.seq", utoa(xatou(seq) + 1));
